# Release preparation procedure
This checklist assumes that you are in a clone of mdm_unidata repository with the remotes upstream for Spinco user repo and origin for your personal fork.  

* Confirm that last daily automated testing was OK
* *git fetch upstream --tags*
* Depnding on the release type:
    * Regular release  
    *git checkout upstream/main -B release*
    * Maintenance release  
    *git checkout tag/_last_release_tag_ -B release*
* *git push -u origin release*
* Edit pom.xml to bump version number to yyyy.nn[.xx]-rc1
* *git commit -m "Bumps version number"*
* Cleanup CHANGELOG
* *git commit -m "Cleans up CHANGELOG"*
* **In case of maintenance release**
  * Fix any issue  
  _As we have no PR's for fixing the issue but it's part of the release procedure,
  the size of the changes must be small.
  If there are too many/big changes, is better to do a regular PR to fix each issue,
  merge to main and release all toguether._
* *git push origin*
* Create PR to merge your_repo/release to Spinco_repo/main
* Wait for PR to be deployed and auto tested
  * Manage any testing error
* Prepare a tag yyyy.nn[.xx]-rc1
* Inform Release Manager that we are ready for Release Testing
* Pre Release testing at the corresponding prtest server (By PO/BA/RM)
* In case of issues  
We only revert the PR that introduced the problem.
It can be fixed afterwards and included in the next release as part of the Sprint procedure.
  * Identify the commit for the PR merge
  * *git revert HASH*
  * Edit pom.xml to bump Version number yyyy.nn-rc[n+1]
  * *git commit -m "Bumps version number"*
  * Edit CHANGELOG to remove the reverted PR and commit
  * *git commit -m "Cleans up CHANGELOG"*
  * *git push origin*
  * Create the PR to merge origin/release to upstream/release
  * Wait for PR to be deployed and tested
    * Manage any testing error
  * Inform Release manager for additional testing
* Edit pom.xml to clean Version number (remove rc) 
* *git commit -m "Bumps version number"*
* Edit CHANGELOG.md to update release date
* *git commit -m "Cleans up CHANGELOG"*
* *git checkout tags/last_release -B changes_from_live*  
    This branch is to have the time comsuming merge of changes from live work done once, in case of issues we can bring again the data from live without all the work
* Import changes from live and cleanup
  You can use any tool you prefer for checking the changes
  The cleanup includes:
  * Ignore files that have no changes but hte new line at then of the file.
  * Ignoring (git reset) changes that are not suposed to be taken from Live.
* *git commit -m "Import changes from live"*
* *git checkout release"
* *git rebase changes_from_live*
  * Manage any conflict
* *git tag yyyy.nn*
* *git push upstream --tags*
* Release
    * Use pipeline
